# Setup
- npm install both / and /vue-typescript-solution


# Running

- /vue-typescript-solution
  - Before doing task 4, keep it running old school using `npm run serve`.
  - To do task 4, run `npm run watch`
    - This creates the /dist folder in there, and keeps it updated for live development.

- To launch the server, npm run serve.

# Assignment 

This assignment creates a single channel chatroom anyone can join. 

The remainder of the features are up to you to implement. 

For now, let user_id: 0 be the user.

For each of this tasks, modify the Vue-typescript-solution to use the newly built interface.

## Task 1: Message basics

Note: start with a single chat room first.
- No need to over-complicate things.
- Simply redirect all users to the same chat room.

GET /messages which ...

Write a generator which mimics the chat spam generator from services/message.ts. 

POST /messages/new which... 

Creates a new message. 

Refreshing the client shall allow client messages to be updated. 

Do not forget to add body-parser.
- Actually i decided to add it for you. Just don't forget it.

## Task 2: websocket based updates

Connect the client to the server such that all new messages will be sent to the client. 

Just a note: Primus consists of two components
- Server
- Client
  - This is generated off the transformer you use. 

Create a route for the client to GET the library.
- Do NOT call it primus*, that's the route they use for the websockets.
- If you get error 426, that's basically your mistake.
- Ensure that the client loads the library.

## Task 3: Message model 

Please remember to connect to database.
- There's no error message if you forget.

Implement a Mongoose Model such that all new messages are saved in the database. 

Load all messages from the database when the app starts. 

## Task 4: (Optional) Static server

## Task 5: (Challenge) file uploads

Using something like [vue-dropzone](https://rowanwins.github.io/vue-dropzone/docs/dist/index.html#/installation), allow uploading files which become hostable urls. 


## Further practice. 

User registration and login with passport. 

Friends list / Multiple message threads. 

Updating /deleting messages. 

Hosting the frontend from server. Implement vue history mode. 


